unit ActiveScriptObj;

interface

uses
  Classes, Forms, Dialogs;

type
  TActiveAppInfo = class(TInterfacedObject, IDispatch)
  protected
    function GetTypeInfoCount(out Count: Integer): HResult; stdcall;
    function GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult; stdcall;
    function GetIDsOfNames(const IID: TGUID; Names: Pointer;
      NameCount, LocaleID: Integer; DispIDs: Pointer): HResult; stdcall;
    function Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
      Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult; stdcall;
  end;

implementation

uses
  ActiveX, Windows, SysUtils;


const
  DISPID_GETEXENAME  = 1;
  DISPID_SHOWMESSAGE = 2;


function TActiveAppInfo.GetIDsOfNames(const IID: TGUID; Names: Pointer; NameCount,
  LocaleID: Integer; DispIDs: Pointer): HResult;
type
  TDispIDsArray = array[0..0] of TDISPID;
  PDispIDsArray = ^TDispIDsArray;
var
  IDs: PDispIDsArray absolute DispIDs;
  i: integer;
  Name: WideString;
begin
  if NameCount > 1 then Result := DISP_E_UNKNOWNNAME
  else
    if NameCount < 1 then Result := E_INVALIDARG
    else Result := S_OK;
  for i := 0 to NameCount - 1 do
    IDs[i] := DISPID_UNKNOWN;
  if NameCount = 1 then
    begin
      Name := PWideChar(Names^);
      if UpperCase(Name) = 'GETEXENAME' then IDs[0] := DISPID_GETEXENAME else
      if UpperCase(Name) = 'SHOWMESSAGE' then IDs[0] := DISPID_SHOWMESSAGE else
       Result := DISP_E_UNKNOWNNAME;
    end;
end;

function TActiveAppInfo.GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult;
begin
  Pointer(TypeInfo) := nil;
  Result := E_NOTIMPL;
end;

function TActiveAppInfo.GetTypeInfoCount(out Count: Integer): HResult;
begin
  Count := 0;
  Result := S_OK;
end;

function TActiveAppInfo.Invoke(DispID: Integer; const IID: TGUID;
  LocaleID: Integer; Flags: Word; var Params; VarResult, ExcepInfo,
  ArgErr: Pointer): HResult;

type
  PVariantArray = ^TVariantArray;
  TVariantArray = array[0..65535] of Variant;
  PIntegerArray = ^TIntegerArray;
  TIntegerArray = array[0..65535] of Integer;
var
  Parms: PDispParams;
  FRetValue : Variant;
begin
  if (DispID = DISPID_GETEXENAME) then
    begin
      if VarResult = nil then
        VarResult := @FRetValue;
      POleVariant(VarResult)^ := Application.ExeName;
      Result := S_OK;
    end
  else
  if (DispID = DISPID_SHOWMESSAGE) then
    begin
      Parms := @Params;
      ShowMessage(PVariantArray(Parms.rgvarg)^[0]);
      Result := S_OK;
    end
  else 

Result := DISP_E_MEMBERNOTFOUND;
end;

end.
