unit CellProp;

interface
uses
  classes, XStringGrid, Graphics;

type
  TCellProperties = class(TComponent)
  private
    FEnabled: boolean;
    FAlignment: TAlignment;
    FEditor: TCellEditor;
    FSelectedColor: TColor;
    FColor: TColor;
    FFont: TFont;
    FSelectedFont: TFont;
    procedure SetAlignment(const Value: TAlignment);
    procedure SetColor(const Value: TColor);
    procedure SetEditor(const Value: TCellEditor);
    procedure SetEnabled(const Value: boolean);
    procedure SetFont(const Value: TFont);
    procedure SetSelectedColor(const Value: TColor);
    procedure SetSelectedFont(const Value: TFont);
    function GetAlignment: TAlignment;
    function GetColor: TColor;
    function GetEditor: TCellEditor;
    function GetEnabled: boolean;
    function GetFont: TFont;
    function GetSelectedColor: TColor;
    function GetSelectedFont: TFont;
  public
    property Color: TColor read GetColor write SetColor;
    property SelectedColor: TColor read GetSelectedColor write SetSelectedColor;
    property Font: TFont read GetFont write SetFont;
    property SelectedFont: TFont read GetSelectedFont write SetSelectedFont;
    property Enabled: boolean read GetEnabled write SetEnabled;
    property Alignment: TAlignment read GetAlignment write SetAlignment;
    property Editor: TCellEditor read GetEditor write SetEditor;
  end;

  TGridRegion = class
  end;

implementation

{ TCellProperties }

function TCellProperties.GetAlignment: TAlignment;
begin
  result := FAlignment;
end;

function TCellProperties.GetColor: TColor;
begin
  result := FColor;
end;

function TCellProperties.GetEditor: TCellEditor;
begin
  result := FEditor;
end;

function TCellProperties.GetEnabled: boolean;
begin
  result := FEnabled;
end;

function TCellProperties.GetFont: TFont;
begin
  result := FFont;
end;

function TCellProperties.GetSelectedColor: TColor;
begin
  result := FSelectedColor;
end;

function TCellProperties.GetSelectedFont: TFont;
begin
  result := FSelectedFont;
end;

procedure TCellProperties.SetAlignment(const Value: TAlignment);
begin
  FAlignment := Value;
end;

procedure TCellProperties.SetColor(const Value: TColor);
begin
  FColor := Value;
end;

procedure TCellProperties.SetEditor(const Value: TCellEditor);
begin
  FEditor := Value;
end;

procedure TCellProperties.SetEnabled(const Value: boolean);
begin
  FEnabled := Value;
end;

procedure TCellProperties.SetFont(const Value: TFont);
begin
  FFont := Value;
end;

procedure TCellProperties.SetSelectedColor(const Value: TColor);
begin
  FSelectedColor := Value;
end;

procedure TCellProperties.SetSelectedFont(const Value: TFont);
begin
  FSelectedFont := Value;
end;

end.
