unit psvActiveScriptReg;

interface

uses
 Windows, SysUtils, Classes, 
  {$IFDEF VER130}DsgnIntf, 
  {$ELSE}
   DesignIntf,
   DesignEditors,
 {$ENDIF}
 psvActiveScript;

type
  TScriptLangProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValueList(List: TStrings);
    procedure GetValues(Proc: TGetStrProc); override;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('System', [TpsvActiveScriptSite, TpsvActiveScriptWindow]);
  RegisterPropertyEditor(TypeInfo(string), TpsvActiveScriptSite, 'ScriptLanguage', TScriptLangProperty);
end;


function TScriptLangProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList, paSortList, paMultiSelect];
end;

procedure TScriptLangProperty.GetValueList(List: TStrings);
begin
 GetActiveScriptParse(List);
end;

procedure TScriptLangProperty.GetValues(Proc: TGetStrProc);
var
  j: integer;
  Values: TStringList;
begin
  Values := TStringList.Create;
  try
    GetValueList(Values);
    for j := 0 to Values.Count - 1 do
      Proc(Values[j]);
  finally
    Values.Free;
  end;
end;


end.